#ifndef lint
static char rcsid[] = "$Header: /net/hopkins/var/home/tristan/mpeg/dec/RCS/mtv.c,v 1.199 1997/11/04 08:25:46 tristan Exp $";
static char copyright[] = "Copyright (c) 1997, MpegTV LLC";
#endif

/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

#include "mtvp/misc.h"

#ifndef HAVE_SEARCH_H

/*
 * This is an emulation of the hcreate(), hsearch() and hdestroy()
 * routines defined by <search.h> on most systems.
 * On systems that do not provide those routines, this
 * emulation based on the DB interface should work.
 */
  
#include "search.h"

static DB *Db;

int hcreate(u_int n)
{
	Db = dbopen(NULL, O_CREAT|O_RDWR, 0, DB_HASH, NULL);
	
	if (Db == NULL) {
		return 0;
	}
	return 1;
}

int hdestroy()
{
	return Db->close(Db);
}

ENTRY	*hsearch(ENTRY entry, ACTION n)
{
	DBT		key;
	DBT		data;
	static ENTRY	ret;
	
	switch (n) {
		case FIND: {
			key.data = entry.key;
			key.size = strlen(entry.key) + 1;
			
			if (Db->get(Db, &key, &data, 0) != 0) {
				return NULL;
			}
			ret.key = entry.key;
			ret.data = data.data;
			return &ret;
		}
		case ENTER: {
			key.data = entry.key;
			key.size = strlen(entry.key) + 1;
			data.data = entry.data;
			data.size = strlen(entry.data) + 1;
			if (Db->put(Db, &key, &data, 0) != 0) {
				return NULL;
			}
			ret.key = entry.key;
			ret.data = data.data;
			return &ret;
		}
		default:
			errno = 0;
			return NULL;
	}
}

#endif /* not HAVE_SEARCH_H */

/* eof */
